#include <unistd.h>
#include <stdio.h>
#include <string.h>
#include <sys/un.h>
#include <sys/types.h>
#include <sys/socket.h>

//ERROR CODES:
//  1 not enough arguments
//  2 connect failed

int main(int argc, char *argv[]){
  if (argc < 2) return 1;
  struct sockaddr_un address; char incoming; int listener, connection; 

  listener = socket(AF_UNIX, SOCK_STREAM, 0);
  address.sun_family = AF_UNIX;
  strncpy(address.sun_path, argv[1], sizeof(address.sun_path) - 1);

  if (bind(listener, (struct sockaddr *) &address, sizeof(struct sockaddr_un)) == -1) return 2;

  listen(listener, 1);
  connection = accept(listener, NULL, NULL);

  while (read(connection, &incoming, sizeof(char))) printf("%c", incoming);

  remove(argv[1]); return 0;
}
